Subject: Re: [PATCH for v5.9] RDS: Replace HTTP links with HTTPS ones

From: Leon Romanovsky <[email-masked]>
Date: Mon, 20 Jul 2020 07:56:26 +0300

On Sun, Jul 19, 2020 at 05:58:45PM +0200, Alexander A. Klimov wrote:
> Rationale:
> Reduces attack surface on kernel devs opening the links for MITM
> as HTTPS traffic is much harder to manipulate.
>
> Deterministic algorithm:
> For each file:
>   If not .svg:
>     For each line:
>       If doesn't contain `\bxmlns\b`:
>         For each link, `\bhttp://[^# \t\r\n]*(?:\w|/)`:
> 	  If neither `\bgnu\.org/license`, nor `\bmozilla\.org/MPL\b`:
>             If both the HTTP and HTTPS versions
>             return 200 OK and serve the same content:
>               Replace HTTP with HTTPS.
>
> Signed-off-by: Alexander A. Klimov <[email-masked]>
> ---
>  Continuing my work started at 93431e0607e5.
>  See also: git log --oneline '--author=Alexander A. Klimov <[email-masked]>' v5.7..master
>  (Actually letting a shell for loop submit all this stuff for me.)
>
>  If there are any URLs to be removed completely
>  or at least not (just) HTTPSified:
>  Just clearly say so and I'll *undo my change*.
>  See also: https://lkml.org/lkml/2020/6/27/64
>
>  If there are any valid, but yet not changed URLs:
>  See: https://lkml.org/lkml/2020/6/26/837
>
>  If you apply the patch, please let me know.
>
>  Sorry again to all maintainers who complained about subject lines.
>  Now I realized that you want an actually perfect prefixes,
>  not just subsystem ones.
>  I tried my best...
>  And yes, *I could* (at least half-)automate it.
>  Impossible is nothing! :)
>
>
>  Documentation/networking/rds.rst | 2 +-
>  1 file changed, 1 insertion(+), 1 deletion(-)

Why can't it be done in one mega-patch?
It is insane to see patch for every file/link.

We have more than 4k files with http:// in it.

➜  kernel git:(m/hw-cleanup) git grep -c http: | tr -d ':[:digit:]' | sort | uniq |wc -l
4292

>
> diff --git a/Documentation/networking/rds.rst b/Documentation/networking/rds.rst
> index 44936c27ab3a..c80d832509e2 100644
> --- a/Documentation/networking/rds.rst
> +++ b/Documentation/networking/rds.rst
> @@ -11,7 +11,7 @@ This readme tries to provide some background on the hows and whys of RDS,
>  and will hopefully help you find your way around the code.
>
>  In addition, please see this email about RDS origins:
> -http://oss.oracle.com/pipermail/rds-devel/2007-November/000228.html
> +https://oss.oracle.com/pipermail/rds-devel/2007-November/000228.html
>
>  RDS Architecture
>  ================
> --
> 2.27.0
>